Subject: Re: [GSoC] Designing a faster index format - Progress report week 13

From: Robin Rosenberg <[email-masked]>
Date: Tue, 24 Jul 2012 00:29:49 +0200

Junio C Hamano skrev 2012-07-22 23.08:
> Thomas Rast <[email-masked]> writes:
>
>> Hum, I'm a bit lost now.
>>
>> What is the status quo?  I take it JGit does not have any of ctime, dev,
>> ino etc., and either leaves the existing value or puts a 0....
>> an argument in favor of splitting stat_crc into its fields again?
>
> A difference is that JGit already has such code, and we would be
> adding a burden to do so yet again.  It also may not just be JGit,
> but anything that wants to be "compatible" with systems whose
> filesystem interface does not give enough data by omitting fields
> the current index pays attention to.
>
> It isn't really a discussion about splitting again, but more about
> not squishing them into a new field in the first place---IIUC, even
> outside Windows, ctime is already problematic on some systems where
> background processes muck with extended attributes Git does not pay
> attention to. If the patch makes us lose the ability to selectively
> ignore changes to certain fields (e.g. changes to dev and ino are
> noticed but ctime are ignored) by squishing them into one new field,
> wouldn't removing them without adding such a useless field a simpler
> way to go?

I wasnt't thinking of splitting, but now I read it again, I do think
it should split. Having size accessible is a good thing, and even better 
if it a 64-bit value so we don't have the modulo-4G problem when looking 
at it. Current size is 4G + 33 bytes, index says 33. Did the
file change or not?

Having access to size make the need for actually
invoking the racy git logic and comparing file content less likely.

As for ctime it is accessible in Java7, though everyone aren't using it 
and JGit code has to run on Java5. An idea is to make an optional 
component, but that doesn't make ctime available everywhere.

-- robin